<?php

/***************************************************************************
 * wikilog.php, version 0.2.2                                             *
 * This is a calendar display and wikilog macro for the PmWiki engine      *
 * Copyright (c) 2003, 2004 John Rankin john.rankin@affinity.co.nz         *
 *                                                                         *
 * To use it, create a GroupHeader page that says [[wikilog]]              *
 * Make sure you press 'Return' at the end of the line, then Save.         *
 * To override the default home page name, write [[wikilog:MagicWord]]     *
 * [[$WikilogTitle]] returns the long form of a date-style page title      *
 *                                                                         *
 * From some other group, you can list the latest entries using the        *
 * [[wikilognews:Group/HomePage]] markup, where 'Group is the name of      *
 * the wikilog group and HomePage is the name of the home page. If         *
 * omitted, HomePage defaults to Group.                                    *
 *                                                                         *
 * The calendar display is copied from a free software program             *
 * written by Stephan Uhlmann <su@su2.info>                                *
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// =========================================================================
// Configuration
// =========================================================================

// This configures how weekdays are presented.
// 0 - american style, Sun to Sat
// 1 - european style, Mon to Sun
$calendar_weekstyle=1;

// This configures how dates are presented.
// 0 - american style, 11/17/2002
// 1 - european style, 17.11.2002
$calendar_datestyle=1;
$space_date_titles =1;
SDV($SpaceDateString,' ');

// How many months relative to the current one to start the calendar.
// Can be a negative (going back) or a positive (going ahead) number.
// The value zero (0) starts the calendar with the current month.
$calendar_months_start=0;

// How many months altogether to show on the calendar.
$calendar_months_number=2;

// How many months after we should wrap and start a new row.
$calendar_month_wrap=3;

// Whether or not to display current entries at the bottom of the calendar.
// Enter 'false' to omit the current period's entries.
$display_log_entries=true;

// Whether to display current entries in ascending or descending order.
// Enter 'false' to show the oldest first.
$newest_first=true;

// Whether to display a summary or full calendar on individual entry pages.
// Enter 'false' to include the calendar on every page.
$summary_only=true;

// This is the default home of each collection (Group) of date pages.
$wikilog_home_page= "{{" . FmtPageName('$Group',$pagename) . "}}";

// Allow page names to be all numerics (not required if freelinks enabled).
#$AnyLetter = "[A-Za-z0-9]";
#$PageTitlePattern = "[A-Z0-9]($AnyLetter*)(-$AnyLetter+)*";
$CalendarPattern = "[0-9]{8}";
$WikiDateCreateFmt = 
      "<a class='nonexistent-date' href='\$PageUrl?action=edit'>\$LinkText</a>";
$LinkPatterns[750]["\\b$GroupNamePattern([\\/.])$CalendarPattern"] = 
     'FmtWikiDateLink';

// Whether to display non-existent date entries in the calendar as day or day?
// Enter 'true' to use the wiki '?' convention for non-existent entries
$day_as_wiki=false;

// Whether to display a list or list and Publish button on wikilog news pages
// Enter 'false' to include a Publish button after the news list
$news_list_only=false;

// Set depending on whether you need ThisPage:?logdate= or ThisPage:&logdate=
$UrlConnector = "?";
#$UrlConnector = "&";

// Month and day names in chosen language
if (!isset($language)) $language = 'en';
if (!isset($scriptlocation)) $scriptlocation = 'scripts';
if (file_exists("$FarmD/local/wikilog-i18n-$language.php"))
    include_once("$FarmD/local/wikilog-i18n-$language.php");
elseif (file_exists("$FarmD/local/$scriptlocation/wikilog-i18n-$language.php"))
    include_once("$FarmD/local/$scriptlocation/wikilog-i18n-$language.php");
else include_once("$FarmD/local/$scriptlocation/wikilog-i18n-en.php");

// Publish button format
SDV($PublishCalendarTagFmt,"<form class='calendarpub' target='_blank' action='\$ScriptUrl' method='get'>
    <input type='hidden' name='pagename' value='\$PageName' />
    <input type='hidden' name='action' value='publish' />
    <input type='hidden' name='logdate' value='\$Year\$Month' />
    <input type='radio' name='order' value='d' checked='checked' />$sequence[0]
    <input type='radio' name='order' value='a' />$sequence[1]
    <input type='submit' value='$publish' /></form>");
/*
SDV($PublishCalendarTagFmt,"<form class='calendarpub' target='_blank' action='\$PageUrl' method='get'>
    <input type='hidden' name='action' value='publish' />
    <input type='hidden' name='logdate' value='\$Year\$Month' />
    <input type='radio' name='order' value='d' checked='checked' />$sequence[0]
    <input type='radio' name='order' value='a' />$sequence[1]
    <input type='submit' value='$publish' /></form>");
*/
/*

You can define different colours for the dates with or without an entry in the
$HTMLHeaderFmt variable. The class attributes for the TD tag are:

calendar-today-entry	: current date and there is an entry
calendar-today-noentry	: current date but there is no entry
calendar-entry		: any other date with an entry
calendar-noentry	: any other date without an entry
calendar-blank      : empty cells at the start and end of month

The class attribute for date links is:

nonexistent-date	: wikilink without an entry

Example:

$HTMLHeaderFmt[] = "<style type = 'text/css'>
div#wikilog {
	margin-top: 10px;
	margin-left: 25px;
	font-size: smaller;
}
td.calendar-today-entry {
	background-color: #ff3333;
	color:            #97694f; 
}
td.calendar-today-noentry { 
	background-color: #ffc3c3;
	color:            #97694f; 
}
td.calendar-entry {
	background-color: #c3ffc3;
	color:            #97694f; 
}
td.calendar-noentry {
	color:            #97694f;
}
a.nonexistent-date  { 
	background: transparent;
	text-decoration: none;
	color: #FF2222;
}
a.nonexistent-date:visited  { 
	background: transparent;
	text-decoration: none;
	color: #FF2222;
}
a.nonexistent-date:hover {
	text-decoration: underline;
	color: #444444;
}
</style>";

*/

// ======================================================================

$logdate = $HTTP_GET_VARS['logdate'];
$order = $HTTP_GET_VARS['order'];
if ($order!='') SDV($HandleActions['publish'],'HandleCalendarPublish');
$DoubleBrackets["/^\\[\\[wikilog(:($PageTitlePattern))?\\]\\]$/e"] = 'view_calendar("$2");';
$DoubleBrackets['/\\[\\[\$WikilogTitle\\]\\]/e'] = 'show_date($pagename);';
$DoubleBrackets["/\\[\\[wikilognews:($GroupNamePattern)(?:\\/($PageTitlePattern))?\\]\\]/e"] = 
	'view_calendar_list("$1","$2");';
SDV($InlineReplacements['/\\[\\[publishcalendar\\]\\]/e'],
   "FmtPageName(\$GLOBALS['PublishCalendarTagFmt'],\$pagename)");

function view_calendar($homepage)
{
	global $calendar_months_start, $calendar_months_number, $calendar_month_wrap, $display_log_entries;
	global $wikilog_home_page, $summary_only, $pagename, $logdate, $PublishCalendarTagFmt;
	global $PageUrlFmt, $WikilogHomeText, $newest_first;

	$r="<p class='datetrail'>";
	$d="";
        $group = FmtPageName('$Group',$pagename);
	$title = FmtPageName('$Title',$pagename);
	if ($homepage != '') $wikilog_home_page = "{{" . $homepage . "}}";

	// check to see whether to display a summary only
	if (IsDate($title) && ($summary_only==true)) {
		$r.=adjacent_entries($group, $title) . "</p>\n";
		$r.="<h3>". longdate($title) . "</h3>\n";
		return $r;
	}

	// start configured number of months before/ahead
	$startingdate = $logdate."16";
	if (IsDate($startingdate)) {
		$year = substr($startingdate,0,4);
		$month= substr($startingdate,4,2);
	} else {
		if (IsDate($title)) {
			$year = substr($title,0,4);
			$month= substr($title,4,2);
		} else {
			$year = date("Y");
			$month= date("m");
		}
	}
	$startingtime = mktime(0,0,0,$month,16,$year);

	// generate the calendar navigation bar
	$currentmonth= date("Y") . date("m");
	$lasttime =$startingtime-$calendar_months_number*2592000;
	$lastmonth= strftime("%Y",$lasttime) . strftime("%m",$lasttime);
	$nexttime =$startingtime+$calendar_months_number*2592000;
	$nextmonth=strftime("%Y",$nexttime) . strftime("%m",$nexttime);

	$r.= "&laquo; ";
	if ($currentmonth < $lastmonth) {
		$r.=calendar_nav($currentmonth) . " - ";
	}
	$r.=calendar_nav($lastmonth) . " - ";
	$r.=calendar_nav($nextmonth);
	if ($currentmonth > $nextmonth) {
		$r.=" - " . calendar_nav($currentmonth);
	}
	$r.=" &raquo;</p>\n";

	// generate the calendar
	$r.="<div id='wikilog'><table class='calendar-outer'><tr>\n";
	$itime=$startingtime+$calendar_months_start*2592000;
	$i=0;

	while ($i<$calendar_months_number)
	{
		$r.="<td class='calendar-outer'>";
		$r.=calendar_month(strftime("%m",$itime),strftime("%Y",$itime),
							$group);
		$r.="</td>\n";
		if ($display_log_entries==true) { 
			$l=list_entries(strftime("%m",$itime),
				strftime("%Y",$itime),$group);
			if ($newest_first) $d = $l.$d; else $d .= $l;
		}
		// +1 month
		// It's actually 30 days which could break when displaying a lot of months
		// but it should be ok when displaying only one or two years at the same time
		$itime=$itime+2592000;
		$i++;
		if (($i%$calendar_month_wrap==0) && ($i!=12)) $r.="</tr><tr>";
	}

	$r.="</tr></table></div>\n";

	// generate the chrono list
	if ($display_log_entries==true)
	{	$WikilogHome = ($WikilogHomeText=='') ? $wikilog_home_page :
			"[[$wikilog_home_page $WikilogHomeText]]";
		$r.= "<p class='wikiloghome'>$WikilogHome:</p><ul class='loglist'>\n";
		$r.=$d . "</ul>[[publishcalendar]]<hr /><p />\n";
		$PublishCalendarTagFmt = str_replace('$Month',$month,
			str_replace('$Year',$year,$PublishCalendarTagFmt));
	}

	// translate the page title
	if (IsDate($title)) {
		$r.="<h3>". longdate($title) . "</h3>";
	}

	return "$r";
}

function view_calendar_list($homegroup,$hometitle)
{
	global $calendar_months_start, $calendar_months_number, $news_list_only;
	global $wikilog_home_page, $pagename, $logdate, $PublishCalendarTagFmt;
	global $PageUrlFmt, $WikilogHomeText, $newest_first;

	$r="<p class='datetrail'>";
	$d="";
	if ($hometitle=='') $hometitle = $homegroup;
	$hometitle = "{{" . $hometitle . "}}";

	// start configured number of months before/ahead
	$startingdate = $logdate."16";
	if (IsDate($startingdate)) {
		$year = substr($startingdate,0,4);
		$month= substr($startingdate,4,2);
	} else {
		$year = date("Y");
		$month= date("m");
		}
	$startingtime = mktime(0,0,0,$month,16,$year);

	// generate the calendar navigation bar
	$currentmonth= date("Y") . date("m");
	$lasttime =$startingtime-$calendar_months_number*2592000;
	$lastmonth= strftime("%Y",$lasttime) . strftime("%m",$lasttime);
	$nexttime =$startingtime+$calendar_months_number*2592000;
	$nextmonth=strftime("%Y",$nexttime) . strftime("%m",$nexttime);

	if ($currentmonth < $lastmonth) {
		$r.=calendar_nav($currentmonth) . " - ";
	} else $r.= "&laquo; ";
	$r.=calendar_nav($lastmonth) . " - ";
	$r.=calendar_nav($nextmonth);
	if ($currentmonth > $nextmonth) {
		$r.=" - " . calendar_nav($currentmonth);
	}
	$r .= " &raquo;</p>\n";

	// generate the calendar
	$itime=$startingtime+$calendar_months_start*2592000;
	$i=0;

	while ($i<$calendar_months_number)
	{
		$l=list_entries(strftime("%m",$itime),strftime("%Y",$itime),
							$homegroup);
		if ($newest_first) $d = $l.$d; else $d .= $l;
	// +1 month
	// It's actually 30 days which could break if displaying a lot of months
	// but it should be ok when displaying only one or two years at a time
		$itime=$itime+2592000;
		$i++;
	}

	// generate the chrono list
	$WikilogHome= ($WikilogHomeText=='') ? "$homegroup/$hometitle" :
		"[[$homegroup/$hometitle $WikilogHomeText]]";
	$r.= "<p class='wikiloghome'>$WikilogHome:</p><ul class='loglist'>\n$d</ul>";
	if ($news_list_only) return $r;
	$r.= "[[publishcalendar]]<p />\n";
	$PublishCalendarTagFmt = str_replace('$Month',$month,
		str_replace('$Year',"$homegroup.$year",$PublishCalendarTagFmt));

	return "$r";
}

function calendar_month($month,$year,$group)
{
	global $pagename, $monthnames, $shortdaynames, $calendar_weekstyle;

	$prefix = $group . "/" . $year . $month;

	$r="";

	$todays_time=mktime(0,0,0,date("m"),date("d"),date("Y"));
	$last_day_of_month=strftime("%d",mktime(0,0,0,$month+1,0,$year));

	$r.="<table class='calendar-inner'>";

	// header with month and year
	$r.="<caption>". $monthnames[$month-1] . " ". $year . "</caption>\n";

	// weekday names
	$r.="<tr>";
	for ($i=$calendar_weekstyle;$i<7+$calendar_weekstyle;$i++)
	{
		$r.="<th>" . $shortdaynames[$i] . "</th>";
	}
	$r.="</tr>\n";

	$count=0;

	// pre-padding
	$r.="<tr>";
	for ($i=0;$i<(strftime("%w",mktime(0,0,0,$month,1,$year))-$calendar_weekstyle+7)%7;$i++)
	{
		$r.="<td class='calendar-blank'>&nbsp;</td>";
		$count++;
	}

	// days
	for ($i=1;$i<=$last_day_of_month;$i++)
	{

		if ($count%7==0) $r.="</tr>\n<tr>";

		if ($i<10) { $day="0".$i; } else { $day=$i; }
		$entryname= $prefix . $day;
		$r.="<td class='calendar-";
		if (abs($todays_time - mktime(0,0,0,$month,$i,$year)) < 86400)
		{
			$r.="today-";
		}
		if (PageExists($entryname))
		{
			$r.="entry'>";
			$r.="<b>[[". $entryname . " " . $day . "]]</b>";
		}
		else
		{
			$r.="noentry'>";
			$r.="[[". $entryname . " " . $day . "]]";
		}
		$r.="</td>";

		$count++;

	}

	// post-padding
	while ($count%7!=0)
	{
		$r.="<td class='calendar-blank'>&nbsp;</td>";
		$count++;
	}

	$r.="</tr>\n";

	$r.="</table>\n";

	return $r;
}

function list_entries($month, $year, $group)
{
	global $pagename,$monthnames,$today,$noentries,$below,$newest_first;

	$r="";
	$title = FmtPageName('$Title',$pagename);
	$prefix = $group . "/" . $year . $month;

	$todays_time=mktime(0,0,0,date("m"),date("d"),date("Y"));
	$last_day_of_month=strftime("%d",mktime(0,0,0,$month+1,0,$year));

	for ($i=1;$i<=$last_day_of_month;$i++)
	{

		if ($i<10) { $day="0".$i; } else { $day=$i; }
		$entrydate = $year . $month . $day;
		$entryname= $prefix . $day;
		if (PageExists($entryname))
		{
			$line="<li>[[". $entryname . " ";
		if (abs($todays_time - mktime(0,0,0,$month,$i,$year)) < 86400)
				{ $line.=$today;
			} else {
				$line.=shortdate($year,$month,$day);
			}
			$line.="]]: ";
			if ($entrydate == $title) {
				$firstpara = "<b>$below</b>";
			} else {
				$snippet = ReadPage($entryname);
				$snippet['text'] .= "\n";
				$firstpara = substr($snippet['text'], 0, 
				  strpos($snippet['text'], "\n"));
 				$firstpara = preg_replace("/^[#*!:]+\s*/","", 
				  htmlspecialchars($firstpara,ENT_NOQUOTES));
		$firstpara = preg_replace("/`\\..*?$/","...",$firstpara);
		$firstpara = preg_replace("/\\[\\[(redirect):(.*)\\]\\]/",
			"''$1s to $group/$2''", $firstpara);
		$firstpara = preg_replace("/\\[\\=(.*?)\\=\\]/se",
		    "Keep(str_replace('\\\"','\"','$1'))",$firstpara);
			}
			$line.=$firstpara . "</li>\n";
			if ($newest_first) $r=$line.$r; else $r.=$line;
		}

	}
	if ($r == "") {
		$r = "<li>$noentries ".$monthnames[$month-1]." $year.</li>\n";
	}

	return $r;
}

function IsDate($title) {
	if (is_numeric($title) && strlen($title) == 8) {
		$year = substr($title,0,4);
		$month= substr($title,4,2);
		$day  = substr($title,6,2);
		return checkdate($month, $day, $year);
	} else {
		return false;
	}
}

function longdate($title) {
	global $calendar_datestyle, $monthnames, $longdaynames;

	$year = substr($title,0,4);
	$month= substr($title,4,2);
	$day  = substr($title,6,2);
	if ($day[0] == "0") { $day = $day[1]; }
	$longmonth = $monthnames[$month-1];
	if ($calendar_datestyle == 0) {
		$r=", $longmonth $day, ";
	} else {
		$r=", $day $longmonth ";
	}
	$dayname=$longdaynames[strftime("%w",mktime(0,0,0,$month,$day,$year))];
	return "$dayname$r$year";
}

function calendar_nav($yearmo) {
	global $calendar_months_number, $UrlConnector, $monthnames, $period;

	$year = substr($yearmo,0,4);
	$r = "[[ThisPage:" . $UrlConnector . "logdate=";
	$r.= $yearmo . " ";
	$r.= $monthnames[substr($yearmo,4,2)-1];
	$r.= " " . $year;
	if ($calendar_months_number == 1 ) {
		$r.= "]]";
	} else {
		$r.= " $period]]";
	}
	return $r;
}

function adjacent_entries($group, $title) {
	global $wikilog_home_page, $UrlConnector, $WikilogHomeText;

	$year =substr($title,0,4);
	$month=substr($title,4,2);
	$day  =substr($title,6,2);
	$prefix = $group . "/" . $year . $month;
	$last_day_of_month=strftime("%d",mktime(0,0,0,$month+1,0,$year));
	$prev="";
	for ($i=1;$i<$day;$i++) {
		if ($i<10) { $prevday="0".$i; } else { $prevday=$i; }
		$entryname = $prefix . $prevday;
		if (PageExists($entryname)) {
			$prev = "&laquo; [[" . $entryname . " ";
			$prev.= shortdate($year,$month,$prevday) . "]] | ";
		}
	}
	$next="";
	for ($i=$last_day_of_month;$i>$day;$i--) {
		if ($i<10) { $nextday="0".$i; } else { $nextday=$i; }
		$entryname = $prefix . $nextday;
		if (PageExists($entryname)) {
			$next = " | [[" . $entryname . " ";
			$next.= shortdate($year,$month,$nextday) . "]] &raquo;";
		}
	}
	$home  = "[[ThisGroup:". wikify($wikilog_home_page) . $UrlConnector;
	$home_text = ($WikilogHomeText=='') ? wikify($wikilog_home_page) :
			$WikilogHomeText;
	$home .= "logdate=$year$month " . $home_text . "]]";
	return $prev . $home . $next;
	
}

function shortdate($year, $month, $day) {
	global $calendar_datestyle;
	return ($calendar_datestyle==0) ? "$month/$day/$year" : "$day.$month.$year";
}

function show_date($page) {
	global $default_date_text;
	$title = FmtPageName('$Title',$page);
	return (IsDate($title)) ? "$default_date_text: ".longdate($title) : $default_date_text;
}

function FmtWikiDateLink($pat,$ref,$btext,$out=NULL,$pname=NULL) {
	global $WikiPageCreateFmt,$WikiDateCreateFmt,$day_as_wiki,$FmtWikiLink;
	if ($day_as_wiki==true) 
		return $FmtWikiLink($pat,$ref,$btext,$out,$pname);
	$hold = $WikiPageCreateFmt;
	$WikiPageCreateFmt = $WikiDateCreateFmt;
	$r = $FmtWikiLink($pat,$ref,$btext,$out,$pname);
	$WikiPageCreateFmt = $hold;
	return $r;
}

function HandleCalendarPublish($pagename) {
	global $HandlePublishFmt,$HTMLTitle,$GCount,$logdate,$order,$noentries;
	global $calendar_months_start,$calendar_months_number,$monthnames;
	global $LastModified,$Now,$TimeFmt;
	if (preg_match('/(.+)\\.([0-9]+)/',$logdate,$match)) {
		$group = $match[1];
		$logdate = $match[2];
	} else
	        $group = FmtPageName('$Group',$pagename);
	$year = substr($logdate,0,4);
	$month= substr($logdate,4,2);
	$startingtime = mktime(0,0,0,$month,16,$year);
	$itime=$startingtime+$calendar_months_start*2592000;
	$i=0;
	while ($i<$calendar_months_number)
	{
		$imonth = strftime("%m",$itime);
		$iyear  = strftime("%Y",$itime);
		$prefix = $group . "/" . $iyear . $imonth;
		$last_day_of_month=
			strftime("%d",mktime(0,0,0,$imonth+1,0,$iyear));
		$entries = 0;
		for ($j=1;$j<=$last_day_of_month;$j++)
		{
			if ($j<10) { $day="0".$j; } else { $day=$j; }
			$entryname = $prefix . $day;
			if (PageExists($entryname))
			{
				$pagearray[] = $iyear . $imonth . $day;
				$entries++;
			}
		}
		if ($entries == 0) $pagearray[] = $iyear . $imonth . "00";
		$itime=$itime+2592000;
		$i++;
	}
	if ($order=='d') rsort($pagearray);
	for($i=0;$i<count($pagearray);$i++) {
		if (substr($pagearray[$i],6,2)=='00') 
			$PublishList[] = "function:PrintText !$noentries " .
				$monthnames[substr($pagearray[$i],4,2)-1] .
				" " . substr($pagearray[$i],0,4);
		else {
			$entrylong = longdate($pagearray[$i]);
			$PublishList[] = 
		"function:PrintText ![[$group.$pagearray[$i] $entrylong]]";
			$PublishList[] = 
		"function:PrintThisPage $group.$pagearray[$i]";
		}
	}
	$GLOBALS['PublishList'] = $PublishList;
	$LastModified = strftime($TimeFmt,$Now);
	$HTMLTitle = "Publish $pagename"; $GCount = 0;
	PrintFmt($pagename,$HandlePublishFmt);
}

?>
